%define section		free

%define origin		kaffe
%define originver	1.1.5
%define libver		1.1.x-cvs
%define priority	1420
%define javaver		1.4.2
%define buildver	00

%define name		java-%{javaver}-%{origin}
%define version		%{javaver}.%{buildver}
%define release		2mdk

%define toplevel_dir	j2sdk%{javaver}_%{buildver}
%define sdklnk		java-%{javaver}-%{origin}
%define jrelnk		jre-%{javaver}-%{origin}
%define sdkdir		%{name}-%{version}
%define jredir		%{sdkdir}/jre
%define sdkbindir	%{_jvmdir}/%{sdklnk}/bin
%define jrebindir	%{_jvmdir}/%{jrelnk}/bin
%define jvmjardir	%{_jvmjardir}/%{name}-%{version}

# Define target architecture we are building for
%define target_cpu %{_target_cpu}
%ifarch %{ix86}
%define target_cpu i386
%endif
%ifarch amd64
%define target_cpu x86_64
%endif
%ifarch ppc
%define target_cpu powerpc
%endif

%define kaffedir	%{_jvmdir}/%{sdkdir}

# Disable checking by default (doesn't even pass on x86)
%define build_check 0
%{expand: %{?_without_CHECK:	%%define build_check 0}}
%{expand: %{?_with_CHECK:	%%define build_check 1}}

Summary:	A free virtual machine for running Java(TM) code
Name:		%{name}
Version:	%{version}
Release:	%{release}
Epoch:		0
License:	GPL
Group:		Development/Java
Url:		http://www.kaffe.org/
#Source0:	http://www.kaffe.org/~robilad/kaffe-1.1.5.tar.bz2
Source0:	%{origin}-cvs.tar.bz2
Patch0:		%{origin}-java.patch.bz2
Patch1:		%{origin}-build.patch.bz2
Obsoletes:	%{origin}
Provides:	%{origin} = 0:%{originver}
Provides:	jre-%{javaver}-%{origin} = %{epoch}:%{version}-%{release}
Provides:	jre-%{origin} = %{epoch}:%{version}-%{release}
Provides:	jre-%{javaver}, java-%{javaver}, jre = %{epoch}:%{javaver}
Provides:	java-%{origin} = %{epoch}:%{version}-%{release}
Provides:	java = %{epoch}:%{javaver}
Provides:	jndi = %{epoch}:%{version}, jndi-ldap = %{epoch}:%{version}
Provides:	jsse = %{epoch}:%{version}
Provides:	jce = %{epoch}:%{version}
Provides:	jdbc-stdext = %{epoch}:3.0, jdbc-stdext = %{epoch}:%{version}
BuildRequires:	alsa-lib-devel
%if 0
BuildRequires:	antlr
BuildRequires:	bcel
%endif
BuildRequires:	chrpath
BuildRequires:	esound-devel
BuildRequires:	gmp-devel
BuildRequires:	eclipse-ecj
#BuildRequires:	jikes > 0:1.22
BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:	gcc-java
BuildRequires:	qt3-devel
BuildRequires:	zip
BuildRequires:	zlib-devel
ExclusiveArch:	%{ix86} ppc x86_64 amd64 ia64
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root

%description
Kaffe is a free virtual machine designed to execute Java(TM) bytecode. 
Kaffe can be configured in two modes. In the first mode, it operates as 
a pure bytecode interpreter (not unlike Javasoft's machine). In the 
second mode, it performs "Just-In-Time" code conversion from the 
abstract code to the host machine's native code.  The second mode will 
ultimately allow execution of Java code at the same speed as standard 
compiled code, while also maintaining the advantages and flexibility of 
code independence.

Note that Sun's Swing 1.1.1 implementation also works with Kaffe.

Install the kaffe package if you need a Java virtual machine.

%package devel
Summary:	Development package with static libs and headers for kaffe
Group:		Development/Java
Obsoletes:	%{origin}-devel
Provides:	%{origin}-devel = 0:%{originver}
#Requires:	jikes > 0:1.22
Requires:	eclipse-ecj
Requires:	%{name} = %{epoch}:%{version}
Requires:	/usr/sbin/update-alternatives
Provides:	java-sdk-%{javaver}-%{origin} = %{epoch}:%{version}-%{release}
Provides:	java-sdk-%{origin} = %{epoch}:%{version}-%{release}
Provides:	java-sdk-%{javaver}, java-sdk = %{epoch}:%{javaver}
Provides:	java-devel-%{origin} = %{epoch}:%{version}-%{release}
Provides:	java-%{javaver}-devel, java-devel = %{epoch}:%{javaver}
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description devel
This package contains the static libraries, header files and documentation
necessary for development of programs that will use kaffe.

You should install this package if you need to develop programs which
will use kaffe functions.

You'll also need to install kaffe package.

%prep
#%setup -q -n %{origin}-%{originver}
%setup -q -n %{origin}
%patch0 -p1
%patch1 -p1
find . -type d -name CVS | xargs rm -rf

%build
%ifarch %{ix86}
export CFLAGS="%optflags -fno-omit-frame-pointer"
%endif
#%{?__cputoolize: %{__cputoolize} -c libltdl}
#%{__libtoolize} --copy --force
#%%{__automake}
#%{__aclocal} -I m4
#%{__autoconf}
export CFLAGS="$CFLAGS `pkg-config --cflags pangoft2`"
export LIBS="$LIBS `pkg-config --libs pangoft2`"
%configure --prefix=%{kaffedir} \
	   --bindir=%{kaffedir}/bin \
	   --libdir=%{kaffedir}/lib \
	   --datadir=%{kaffedir}/share \
	   --includedir=%{kaffedir}/include \
	   --mandir=%{kaffedir}/man \
%if 0
	   --with-antlr-jar=%{_javadir}/antlr.jar \
	   --with-bcel=%{_javadir}/bcel.jar \
%endif
	   --disable-debug \
	   --disable-rpath \
           --enable-gcj \
           --disable-gtk-cairo \
           --with-kaffe-x-awt \
           --with-kaffe-qt-awt \
           --with-jni-library-path=%{_libdir} \
           --with-rt-jar=no \
           --with-jikes=%{_bindir}/ecj \
%if 0
           --enable-gjdoc \
%else
           --disable-gjdoc \
%endif
           --disable-libxmlj \
	   --with-extensions=all

%make JAVAC_FLAGS="-classpath `pwd`/libraries/javalib/rt.jar -bootclasspath lib/" \

%if %{build_check}
BUILD_CHECK=yes
%endif
[[ -n "$BUILD_CHECK" ]] && {
echo ====================TESTING=========================
# All tests must pass on x86 and x86-64
%ifarch %{ix86} x86_64
%make check
%else
%make -k check || echo "make check failed"
%endif
echo ====================TESTING END=====================
}

%install
%__rm -rf %{buildroot}
%makeinstall_std
%{__bzip2} -9 %{buildroot}%{kaffedir}/man/man1/kaffe.1
chrpath -d %{buildroot}%{kaffedir}/jre/lib/%{target_cpu}/{libgtkpeer.so.0.0.0,libjawt.so.0.0.0,libxawt-%{libver}.so}
%__rm -rf %{buildroot}%{kaffedir}/share/doc
(cd %{buildroot}%{_jvmdir}/%{sdkdir}/lib && \
ln -sf %{_jvmdir}/%{jredir}/lib/rt.jar tools.jar)

# extensions handling
install -d -m 755 %{buildroot}%{jvmjardir}
pushd %{buildroot}%{jvmjardir}
   ln -sf %{_jvmdir}/%{jredir}/lib/rt.jar jsse-%{version}.jar
   ln -sf %{_jvmdir}/%{jredir}/lib/rt.jar jce-%{version}.jar
   ln -sf %{_jvmdir}/%{jredir}/lib/rt.jar jndi-%{version}.jar
   ln -sf %{_jvmdir}/%{jredir}/lib/rt.jar jndi-ldap-%{version}.jar
   ln -sf %{_jvmdir}/%{jredir}/lib/rt.jar jdbc-stdext-%{version}.jar
   ln -sf jdbc-stdext-%{version}.jar jdbc-stdext-3.0.jar
   for jar in *-%{version}.jar ; do
      ln -sf ${jar} $(echo $jar | sed "s|-%{version}.jar|-%{javaver}.jar|g")
      ln -sf ${jar} $(echo $jar | sed "s|-%{version}.jar|.jar|g")
   done
popd

# versionless symlinks
pushd %{buildroot}%{_jvmdir}
ln -sf %{jredir} %{jrelnk}
ln -sf %{sdkdir} %{sdklnk}
popd

pushd %{buildroot}%{_jvmjardir}
ln -sf %{sdkdir} %{jrelnk}
ln -sf %{sdkdir} %{sdklnk}
popd

pushd developers
%{__chmod} 755 build_mathnamespace mauve-html-gen.pl mauve-results.sh
popd

%clean
%__rm -rf %{buildroot}

%post
update-alternatives --install %{_bindir}/java java %{jrebindir}/java %{priority} \
--slave %{_jvmdir}/jre                     jre                         %{_jvmdir}/%{jrelnk} \
--slave %{_jvmjardir}/jre                  jre_exports                 %{_jvmjardir}/%{jrelnk} \
--slave %{_bindir}/rmiregistry             rmiregistry                 %{jrebindir}/rmiregistry

update-alternatives --install %{_jvmdir}/jre-%{origin} jre_%{origin} %{_jvmdir}/%{jrelnk} %{priority} \
--slave %{_jvmjardir}/jre-%{origin}        jre_%{origin}_exports     %{_jvmjardir}/%{jrelnk}

update-alternatives --install %{_jvmdir}/jre-%{javaver} jre_%{javaver} %{_jvmdir}/%{jrelnk} %{priority} \
--slave %{_jvmjardir}/jre-%{javaver}       jre_%{javaver}_exports      %{_jvmjardir}/%{jrelnk}

%post devel
update-alternatives --install %{_bindir}/javac javac %{sdkbindir}/javac %{priority} \
--slave %{_jvmdir}/java                     java_sdk                    %{_jvmdir}/%{sdklnk} \
--slave %{_jvmjardir}/java                  java_sdk_exports            %{_jvmjardir}/%{sdklnk} \
--slave %{_bindir}/appletviewer             appletviewer                %{sdkbindir}/appletviewer \
--slave %{_bindir}/jar                      jar                         %{sdkbindir}/jar \
--slave %{_bindir}/jarsigner                jarsigner                   %{sdkbindir}/jarsigner \
--slave %{_bindir}/javadoc                  javadoc                     %{sdkbindir}/javadoc \
--slave %{_bindir}/javah                    javah                       %{sdkbindir}/javah \
--slave %{_bindir}/javap                    javap                       %{sdkbindir}/javap \
--slave %{_bindir}/jdb                      jdb                         %{sdkbindir}/jdb \
--slave %{_bindir}/native2ascii             native2ascii                %{sdkbindir}/native2ascii \
--slave %{_bindir}/rmic                     rmic                        %{sdkbindir}/rmic \
--slave %{_bindir}/serialver                serialver                   %{sdkbindir}/serialver

update-alternatives --install %{_jvmdir}/java-%{origin} java_sdk_%{origin} %{_jvmdir}/%{sdklnk} %{priority} \
--slave %{_jvmjardir}/java-%{origin}        java_sdk_%{origin}_exports     %{_jvmjardir}/%{sdklnk}

update-alternatives --install %{_jvmdir}/java-%{javaver} java_sdk_%{javaver} %{_jvmdir}/%{sdklnk} %{priority} \
--slave %{_jvmjardir}/java-%{javaver}       java_sdk_%{javaver}_exports      %{_jvmjardir}/%{sdklnk}

%postun
if [ $1 -eq 0 ]; then
  update-alternatives --remove java %{jrebindir}/java
fi

%postun devel
if [ $1 -eq 0 ]; then
  update-alternatives --remove javac %{sdkbindir}/javac
  update-alternatives --remove java_sdk_%{origin}  %{_jvmdir}/%{sdklnk}
  update-alternatives --remove java_sdk_%{javaver} %{_jvmdir}/%{sdklnk}
fi

%files
%defattr(-,root,root)
%doc AUTHORS license* README RELEASE-NOTES THIRDPARTY TODO WHATSNEW
%dir %{kaffedir}
%dir %{kaffedir}/bin
%{kaffedir}/bin/java
%{kaffedir}/bin/kaffe
%{kaffedir}/jre
%{kaffedir}/lib
%{kaffedir}/man
%{kaffedir}/share
%{_jvmdir}/%{jrelnk}
%{_jvmjardir}/%{jrelnk}
%{jvmjardir}/*.jar

%files devel
%defattr(-,root,root)
%doc ABOUT-NLS BUILD_ENVIRONMENT ChangeLog.* developers FAQ
%{kaffedir}/bin/appletviewer
%{kaffedir}/bin/install-jar
%{kaffedir}/bin/jar
%{kaffedir}/bin/javadoc
%{kaffedir}/bin/javac
%{kaffedir}/bin/javah
%{kaffedir}/bin/javap
%{kaffedir}/bin/jdb
%{kaffedir}/bin/kaffeh
%{kaffedir}/bin/native2ascii
%{kaffedir}/bin/rmic
%{kaffedir}/bin/rmiregistry
%{kaffedir}/bin/serialver
%{kaffedir}/include
%{_jvmdir}/%{sdklnk}
%{_jvmjardir}/%{sdklnk}

%changelog
* Fri Sep 09 2005 David Walluck <walluck@mandriva.org> 0:1.4.2.00-2mdk
- CVS (20050910)
- use ecj instead of jikes
- disable libxmlj (too experimental)
- disable bcel until it is in main
- disable gjdoc until antlr is in main

* Sun May 15 2005 David Walluck <walluck@mandriva.org> 0:1.4.2.00-1mdk
- release

* Tue Apr 05 2005 David Walluck <david@jpackage.org> 0:1.4.2.00-1jpp
- release
